create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_ON_ALBUMS_COUNT(IN _id_album int, IN _field int(10),
                                                                  IN _query varchar(192), IN _filter varchar(192),
                                                                  IN _limit_size_a bigint, IN _limit_size_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;


SET @_id_album = _id_album;
SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_filter = CONCAT("%",_filter,"%");
SET @_limit_size_a = _limit_size_a;
SET @_limit_size_b = _limit_size_b;
SET @_state = _query;

SET @_year = year(_filter);
SET @_month = month(_filter);

SET sqlcommand = " SELECT count(1) as total
				FROM assets a, assets_albums_related aar
 WHERE a.id_asset = aar.id_asset AND a.deleted = 0 AND aar.id_album = @_id_album ";

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like @_name OR description like @_description OR ((SELECT count(1) FROM assets_tags at, assets_tags_related atr WHERE at.id_tag = atr.id_tag AND atr.id_asset = a.id_asset AND name_stripped like @_tags_stripped) > 0))  ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_cfilter) )) AND (name like @_name OR description like @_description) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(a.register_date) = @_year AND month(a.register_date) = @_month) AND (name like @_name OR description like @_description) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(a.register_date) = @_year) AND (name like @_name OR description like @_description) ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_filter) AND (name like @_name OR description like @_description) ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (mime_type like @_filter) AND (name like @_name OR description like @_description) ");
WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (CONCAT(width,'x',height) like @_filter) AND (name like @_name OR description like @_description) ");
WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (size BETWEEN @_limit_size_a AND @_limit_size_b) AND (name like @_name OR description like @_description) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
END CASE;

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

EXECUTE stmt;  

COMMIT;

END;

