create
    definer = skoiypp@`%` procedure SP_GET_POSTS_ON_DOSSIERS(IN _id_dossier int, IN _field int(10),
                                                             IN _query varchar(192), IN _order tinyint,
                                                             IN _order_by tinyint, IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM posts_dossiers_related WHERE id_dossier = _id_dossier;
	SET @_limit_b = _limit_b;
END IF;

SET @_id_dossier = _id_dossier;
SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_state = _query;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = " SELECT id_l10n,p.id_post,iso_language,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,publish_date,begin_date,end_date, 
p.register_date, state FROM posts p, posts_dossiers_related pdr, posts_l10n pln
 WHERE p.id_post = pdr.id_post AND pln.id_post = p.id_post AND pdr.id_dossier = ? ";

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like ? OR description like ? OR ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like ?) > 0)) ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like ? ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like ? ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like ?) > 0) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND state = ? ");
ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
END CASE;

CASE
WHEN _order_by = 1 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY title ASC");
WHEN _order_by = 2 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY publish_date ASC");
WHEN _order_by = 1 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY title DESC");
WHEN _order_by = 2 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY publish_date DESC");
ELSE SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY publish_date DESC");
END CASE;

 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _field = 0 THEN
EXECUTE stmt USING @_id_dossier,@_title,@_description,@_tags_stripped,@_limit_a,@_limit_b;
WHEN _field = 1 THEN
EXECUTE stmt USING @_id_dossier,@_title,@_limit_a,@_limit_b;
WHEN _field = 2 THEN
EXECUTE stmt USING @_id_dossier,@_description,@_limit_a,@_limit_b;
WHEN _field = 3 THEN
EXECUTE stmt USING @_id_dossier,@_tags_stripped,@_limit_a,@_limit_b;
WHEN _field = 4 THEN
EXECUTE stmt USING @_id_dossier,@_state,@_limit_a,@_limit_b;
ELSE 
EXECUTE stmt USING @_id_dossier,@_limit_a,@_limit_b;    
END CASE;

COMMIT;

END;

