create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_POSTS_LATEST_COUNT(IN _id_collection INT, IN _id_dossier INT,
                                                                      IN _iso_lang varchar(10), IN _field INT,
                                                                      IN _filter VARCHAR(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_collection = _id_collection;
SET @_id_dossier = _id_dossier;
SET @_iso_lang = _iso_lang;
SET @_cfilter = _filter;


SET sqlcommand = "SELECT count(distinct id_l10n) as total 
FROM posts_l10n pl10n, posts_dossiers_related pdr WHERE pl10n.id_post = pdr.id_post AND state = 5 ";

IF(_iso_lang <> '')
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND iso_language = ? ");
END IF;

IF(_id_collection <> -1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = ?) ");
END IF;

IF(_id_dossier <> -1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND id_dossier = ? ");
END IF;

IF(_field = 1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND DATEDIFF(now(), publish_date) <= @_cfilter ");
END IF;

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

IF(_iso_lang <> '')
THEN
    CASE
		WHEN _id_collection <> -1 AND _id_dossier = -1 THEN
		EXECUTE stmt USING @_iso_lang,@_id_collection;
		WHEN _id_collection = -1 AND _id_dossier <> -1 THEN
		EXECUTE stmt USING @_iso_lang,@_id_dossier;
		WHEN _id_collection <> -1 AND _id_dossier <> -1 THEN
		EXECUTE stmt USING @_iso_lang,@_id_collection,@_id_dossier;
		ELSE 
		EXECUTE stmt;    
	END CASE; 
ELSE
    CASE
		WHEN _id_collection <> -1 AND _id_dossier = -1 THEN
		EXECUTE stmt USING @_id_collection;
		WHEN _id_collection = -1 AND _id_dossier <> -1 THEN
		EXECUTE stmt USING @_id_dossier;
		WHEN _id_collection <> -1 AND _id_dossier <> -1 THEN
		EXECUTE stmt USING @_id_collection,@_id_dossier;
		ELSE 
		EXECUTE stmt;    
	END CASE; 
END IF;

COMMIT;

END;

