create
    definer = skoiypp@`%` procedure SP_GET_VIDEO_PLAYLISTS_ON_CHANNELS(IN _id_channel int, IN _name varchar(192),
                                                                       IN _order tinyint, IN _order_by tinyint,
                                                                       IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_channel = _id_channel;

SET @_name = _name;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT pcr.id_channel, pcr.id_playlist, p.management_name, p.publish_date,p.begin_date, p.end_date,pcr.position,FN_GET_VIDEO_PLAYLIST_HAS_LIVE_CONTENT(pcr.id_playlist) as has_live,FN_GET_VIDEO_PLAYLIST_HAS_VIDEO_CONTENT(pcr.id_playlist) as has_vod,FN_GET_VIDEO_IS_PLAYLISTS_ON_CHANNEL(pcr.id_playlist) as on_channel, p.state
	FROM playlists_channels_related pcr, playlists p WHERE p.id_playlist = pcr.id_playlist AND pcr.id_channel = ? ";

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM playlists_channels_related WHERE id_channel = _id_channel;
	SET @_limit_b = _limit_b;
END IF;

IF(_name <> '')
THEN
   SET @_name = CONCAT("%",_name,"%");
   SET sqlcommand = CONCAT(sqlcommand," AND (p.management_name like ? ) ");
END IF;

CASE
WHEN _order_by = 1 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, "ORDER BY p.management_name ASC");
WHEN _order_by = 1 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, "ORDER BY p.management_name DESC");
ELSE SET sqlcommand = CONCAT(sqlcommand, "ORDER BY pcr.position ASC");
END CASE;

 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _name <> '' THEN
EXECUTE stmt USING @_id_channel,@_name,@_name,@_limit_a,@_limit_b;
ELSE 
EXECUTE stmt USING @_id_channel,@_limit_a,@_limit_b;    
END CASE;

COMMIT;

END;

