create
    definer = skoiypp@`%` procedure SP_SET_ACCOUNT_BULK_UPLOAD(IN _id_account int, IN _id_service int,
                                                               IN _code varchar(255), IN _password varchar(255),
                                                               IN _upload_max_size bigint, IN _uptype int(10),
                                                               IN _shared tinyint(1), IN _id_directory int(10),
                                                               IN _active tinyint(1), IN _end_date datetime)
BEGIN

DECLARE _service_name VARCHAR(192);
DECLARE _default_upload_max_size bigint(20);
DECLARE _default_uptype int(10);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_account FROM accounts WHERE id_account = _id_account) AND NOT EXISTS(SELECT id_account FROM accounts_bulk_uploads WHERE id_account = _id_account AND code = _code)
THEN
	IF NOT EXISTS(SELECT id_service FROM accounts_services WHERE id_service = _id_service AND id_account = _id_account)
	THEN
		SELECT -2 as return_code;
	ELSE

		SELECT name into _service_name FROM services WHERE id_service = _id_service; 
		CASE
			WHEN _service_name = 'assets' THEN
				SELECT upload_max_size,1 into _default_upload_max_size, _default_uptype FROM accounts_assets_settings WHERE id_account = _id_account;
			WHEN _service_name = 'video' THEN
				SELECT upload_max_size,2 into _default_upload_max_size, _default_uptype FROM accounts_video_settings WHERE id_account = _id_account;
			WHEN _service_name = 'archive' THEN
				SELECT upload_max_size,3 into _default_upload_max_size, _default_uptype FROM accounts_archive_settings WHERE id_account = _id_account;
			WHEN _service_name = 'ads' THEN
				SELECT upload_max_size,2 into _default_upload_max_size, _default_uptype FROM accounts_ads_settings WHERE id_account = _id_account;
			ELSE 
				SELECT upload_max_size into _default_upload_max_size FROM accounts_assets_settings WHERE id_account = _id_account; 
		END CASE;	
	
		IF(_shared = 0)
		THEN
			INSERT into accounts_bulk_uploads(id_account,id_service,code, password,upload_max_size,uptype,shared,id_directory,active,end_date,register_date) VALUES(_id_account,_id_service,_code, '',_default_upload_max_size,_default_uptype,_shared,_id_directory,_active,'0000-00-00 00:00:00',now());
		ELSE
			IF(_upload_max_size = 0) THEN SET _upload_max_size = _default_upload_max_size; END IF;
			INSERT into accounts_bulk_uploads(id_account,id_service,code, password,upload_max_size,uptype,shared,id_directory,active,end_date,register_date) VALUES(_id_account,_id_service,_code, _password,_upload_max_size,_default_uptype,_shared,_id_directory,_active,_end_date,now());
		END IF;

		SELECT id_upload,id_account,id_service,code, password,upload_max_size,FN_GET_UPLOAD_TYPES(uptype) as uptypes,shared,id_directory,active,maintenance,end_date,register_date FROM accounts_bulk_uploads 
		WHERE id_account = _id_account AND code = _code;

	END IF;
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

