create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_POSTS_MGO()
BEGIN

-- CALL SP_SET_PUBLISH_POSTS_MGO();

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

INSERT into posts_publish_log_2(begin_publish_date) VALUES(now());

-- ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- BEGIN_DATE
UPDATE posts_l10n SET begin_date = date(now()) WHERE begin_date <= date(now());
UPDATE dossiers SET begin_date = date(now()) WHERE begin_date <= date(now());
UPDATE collections SET begin_date = date(now()) WHERE begin_date <= date(now());

-- ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- OFFLINE
CALL SP_SET_PUBLISH_POSTS_COLLECTIONS_TO_OFFLINE();
CALL SP_SET_PUBLISH_POSTS_DOSSIERS_TO_OFFLINE();
CALL SP_SET_PUBLISH_POSTS_TO_OFFLINE();
CALL SP_SET_PUBLISH_POSTS_STICKERS_TO_OFFLINE();

-- ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- SCHEDULED
UPDATE collections SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;
-- ONLINE
UPDATE collections SET state = 5 WHERE (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now())) AND state = 4;

-- ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

UPDATE dossiers SET state = FN_GET_POSTS_HIGHEST_STATE_COLLECTIONS(id_dossier) WHERE state in (4,5);

-- SCHEDULED
UPDATE dossiers SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;
-- ONLINE
UPDATE dossiers SET state = 5 WHERE (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now())) AND state = 4 AND FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(id_dossier) > 0 AND FN_GET_POSTS_HIGHEST_STATE_COLLECTIONS(id_dossier) = 5;

-- ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- SCHEDULED
UPDATE posts_l10n SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;
INSERT into posts_sync_updated_2(id_post,action_type,register_date) 
SELECT id_post,3,now() FROM posts WHERE id_post in (SELECT id_post FROM posts_l10n WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 4); 	

-- ONLINE
INSERT into posts_sync_updated_2(id_post,action_type,register_date) 
SELECT id_post,2,now() FROM posts WHERE id_post in (SELECT id_post FROM posts_l10n WHERE (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now())) AND state = 4 AND FN_GET_POSTS_HIGHEST_STATE_DOSSIERS(id_post) = 5);
UPDATE posts_l10n SET state = 5 WHERE (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now())) AND state = 4 AND FN_GET_POSTS_HIGHEST_STATE_DOSSIERS(id_post) = 5;

-- ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- SCHEDULED
UPDATE posts_stickers_related SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;
INSERT into posts_sync_updated_2(id_post,action_type,register_date) 
SELECT id_post,2,now() FROM posts WHERE id_post in (SELECT id_post FROM posts_stickers_related WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5);

UPDATE dossiers_stickers_related SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;
INSERT into posts_sync_updated_2(id_dossier,action_type,register_date) 
SELECT id_dossier,2,now() FROM dossiers WHERE id_dossier in (SELECT id_dossier FROM dossiers_stickers_related WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5);

UPDATE collections_stickers_related SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;
INSERT into posts_sync_updated_2(id_collection,action_type,register_date) 
SELECT id_collection,2,now() FROM collections WHERE id_collection in (SELECT id_collection FROM collections_stickers_related WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5);

-- SCHEDULED
UPDATE posts_stickers_related SET state = 4 WHERE id_post in (SELECT id_post FROM posts_l10n WHERE state <> 5);
UPDATE dossiers_stickers_related SET state = 4 WHERE id_dossier in (SELECT id_dossier FROM dossiers_l10n WHERE state <> 5);
UPDATE collections_stickers_related SET state = 4 WHERE id_collection in (SELECT id_collection FROM collections_l10n WHERE state <> 5);
-- ONLINE
UPDATE posts_stickers_related SET state = 5 WHERE begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now()) AND state = 4;
UPDATE dossiers_stickers_related SET state = 5 WHERE begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now()) AND state = 4;
UPDATE collections_stickers_related SET state = 5 WHERE begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now()) AND state = 4;

-- ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- CONFIRM ALL NOT ASSOCIATED TO DOSSIERS
INSERT into posts_sync_updated_2(id_post,action_type,register_date) 
SELECT id_post,3,now() FROM posts WHERE id_post not in (SELECT id_post FROM posts_dossiers_related) AND update_date > DATE_ADD(now(),INTERVAL -5 MINUTE);

-- ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

call SP_SET_PUBLISH_POSTS_TO_SCHEDULE_ON_IDLE_DOSSIERS();
call SP_SET_PUBLISH_POSTS_STICKERS_REORDER();
call SP_SET_PUBLISH_POSTS_DOSSIERS_COLLECTIONS_REORDER();
call SP_SET_PUBLISH_POSTS_COLLECTIONS_REORDER();

	SELECT 0 as return_code;

COMMIT;

END;

