create
    definer = skoiypp@`%` procedure SP_SET_TASK_ARCHIVE_CLIP_PREVIEW(IN _id_account int(10),
                                                                     IN _account_token varchar(255),
                                                                     IN _id_clip int(10), IN _input_path varchar(255),
                                                                     IN _output_path varchar(255),
                                                                     IN _file_name varchar(255),
                                                                     IN _source varchar(255), IN _width int(10),
                                                                     IN _height int(10), IN _seconds int(10),
                                                                     IN _aspect_ratio varchar(255),
                                                                     IN _video_codec varchar(255),
                                                                     IN _audio_codec varchar(255),
                                                                     IN _audio_rate varchar(255),
                                                                     IN _video_rate varchar(255),
                                                                     IN _created_clip_date date)
BEGIN

DECLARE _command text;
DECLARE _ratio varchar(255);
DECLARE _scale varchar(255);
DECLARE _output_path_clean varchar(255);
DECLARE _clip_preview_name varchar(255);

DECLARE _year varchar(25);
DECLARE _month varchar(25);
DECLARE _day varchar(25);



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SELECT _width/_height into _ratio;

SET _year = year(_created_clip_date);
SET _month = month(_created_clip_date);
SET _day = day(_created_clip_date);

IF(_month < 10) THEN SET _month = CONCAT(0,_month); END IF;
IF(_day < 10) THEN SET _day = CONCAT(0,_day); END IF;

SET _output_path_clean = _output_path;
SET _input_path = CONCAT(_input_path,'/',_account_token,'/',_year,'/',_month,'/',_day,'/');
SET _output_path = CONCAT(_output_path,'/',_account_token,'/',_year,'/',_month,'/',_day,'/');
SET _clip_preview_name = CONCAT(_file_name,'.mp4');


SET _command = CONCAT_WS(' ','ffmpeg -y -threads 8 -i',(CONCAT(_input_path,_source)));


SELECT _width/_height into _ratio;

IF(SELECT _ratio in (16/9,854/480))
THEN
	SET _scale = "480:270";
ELSE

IF(SELECT _ratio in (9/16,480/854))
THEN
	SET _scale = "270:480";
ELSE

IF(SELECT _ratio in (4/3))
THEN
	SET _scale = "360:270";
ELSE

IF(SELECT _ratio in (64/27))
THEN
	SET _scale = "640:270";
ELSE

IF(SELECT _ratio in (40/17))
THEN
	SET _scale = "640:272";
ELSE

IF(SELECT _ratio in (1))
THEN
	SET _scale = "270:270";
ELSE

	SET _scale = "480:270";
END IF;
END IF;
END IF;
END IF;
END IF;
END IF;


	SET _command = CONCAT(_command,' -b:a 64k -ac 1 -acodec aac -vcodec mpeg4 -b:v 400k -vf scale=',_scale,' -f mp4 ',(CONCAT(_output_path,_file_name,'_.mp4')),' && ',
	'ffmpeg -i ',(CONCAT(_output_path,_file_name,'_.mp4')),' -acodec copy -vcodec libx264 ', (CONCAT(_output_path,_file_name,'.mp4')),' && ',
	'rm -f ',(CONCAT(_output_path,_file_name,'_.mp4')));

	INSERT into archive_preview_clip_queue(id_account,account_token,output_path,id_clip,clip,command,created_clip_date,register_date) 
	VALUES(_id_account,_account_token,_output_path_clean,_id_clip,_clip_preview_name,_command,_created_clip_date,now());

	INSERT into archive_preview_clip_history(id_account,account_token,output_path,id_clip,clip,command,created_clip_date,register_date) 
	VALUES(_id_account,_account_token,_output_path_clean,_id_clip,_clip_preview_name,_command,_created_clip_date,now());

SELECT 0 as return_code;

COMMIT;


END;

