<?php

namespace Skoiy\Mongo\Indexes;

class Index
{
    private $key;
    private $options;

    public function __construct($key, array $options = [])
    {
        $this->key = $key;
        $this->options = $options;
    }

    /**
     * @return mixed
     */
    public function getKey()
    {
        return $this->key;
    }

    /**
     * @return mixed
     */
    public function getOptions()
    {
        return $this->options;
    }

    public function toArray()
    {
        $commandOptionKeys = ['maxTimeMS' => 1, 'session' => 1, 'writeConcern' => 1];
        $indexOptions = array_diff_key($this->options, $commandOptionKeys);
        $commandOptions = array_intersect_key($this->options, $commandOptionKeys);
        return ['key' => $this->getKey()] + $indexOptions;
    }

    public function __toString()
    {
        return sprintf("%s_%s", current(array_keys($this->key)), current(array_values($this->key)));
    }
}
