<?php

namespace Skoiy\Mongo;

use Skoiy\Skoiy;
use Illuminate\Container\Container;
use MongoDB\Driver\Monitoring\CommandSubscriber;
use Skoiy\Mongo\Repository\Authors;
use Skoiy\Mongo\Repository\Collections;
use Skoiy\Mongo\Repository\Dossiers;
use Skoiy\Mongo\Repository\Posts;
use Skoiy\Mongo\Repository\Stickers;
use Skoiy\Mongo\Subscribers\MySubscriber;

class Mongo
{
    private $map = [
        Collection::COLLECTIONS => Collections::class,
        Collection::DOSSIERS => Dossiers::class,
        Collection::POSTS => Authors::class,
        Collection::STICKERS => Posts::class,
        Collection::AUTHORS => Stickers::class
    ];

    /**
     * @var CommandSubscriber
     */
    private $subscriber;

    public function database($name)
    {
        $this->skoiy = Container::getInstance()->get(Skoiy::class);
        $this->skoiy->setDatabaseNameResolver(function ($idAccount) use ($name) {
            return $name;
        });
        return $this;
    }

    public function from($collectionName)
    {
        return $this->resolveRepository($collectionName);
    }

    private function resolveRepository($collectionName)
    {
        $instance = $this->map[$collectionName];
        $repository = new $instance(Container::getInstance());
        $repository->setSkoiy($this->skoiy);
        return $repository;
    }

    public static function listen(callable $callable)
    {
        $subscriber1 = new MySubscriber("one", $callable);
        \MongoDB\Driver\Monitoring\addSubscriber($subscriber1);
    }
}
