<?php

namespace Skoiy\Mongo\Paginator;

use MongoDB\Driver\Cursor;
use Illuminate\Pagination\LengthAwarePaginator as OriginalLengthAwarePaginator;

class LengthAwarePaginator extends OriginalLengthAwarePaginator
{
    /**
     * @var Cursor
     */
    private $cursor;

    public function __construct($items, $total, $perPage, $currentPage = null, array $options = [])
    {
        parent::__construct($items, $total, $perPage, $currentPage, $options);
    }

    /**
     * setCursor
     *
     * @param Cursor $cursor
     * @return void
     */
    public function setCursor(Cursor $cursor)
    {
        $this->cursor = $cursor;
    }

    /**
     * getCursor
     *
     * @return Cursor
     */
    public function getCursor()
    {
        return $this->cursor;
    }

    /**
     * Get the instance as an array.
     *
     * @return array
     */
    public function toArray()
    {
        return [
            'page' => $this->currentPage(),
            'totalPages' => $this->lastPage(),
            'totalResults' => $this->total(),
            'data' => $this->items->toArray(),
        ];
    }
}
