<?php

namespace Skoiy\Mongo;

class PipelineBuilder
{
    /**
     * @var callable[]
     */
    private $stages = [];

    public function when($condition, $stage)
    {
        if($condition)
            $this->stages[] = $stage;
        return $this;
    }

    public function add($stage)
    {
        $this->stages[] = $stage;
        return $this;
    }

    public function build()
    {
        return array_map(function($stage){
            if(is_callable($stage)) {
                return $stage();
            }
            return $stage;
        }, $this->stages);
    }
}
