<?php

namespace Skoiy\Mongo\Subscribers;

use MongoDB\Driver\Monitoring\CommandSubscriber;

class MySubscriber implements CommandSubscriber
{
    private $instanceName;
    private $callable;

    public function __construct($instanceName, callable $callable)
    {
        $this->instanceName = $instanceName;
        $this->callable = $callable;
    }

    public function commandStarted(\MongoDB\Driver\Monitoring\CommandStartedEvent $event): void
    {
        ($this->callable)($event);
//        print_r($event->getCommand());
//        echo "\n";
//        echo \MongoDB\BSON\toRelaxedExtendedJSON(\MongoDB\BSON\fromPHP($event->getCommand()));
//        echo "\n";
//        echo "- ({$this->instanceName}) - started: ", $event->getCommandName(), "\n";
    }

    public function commandSucceeded(\MongoDB\Driver\Monitoring\CommandSucceededEvent $event): void
    {
        ($this->callable)($event);
//        print_r($event);
//        echo "commandSucceeded";
    }

    public function commandFailed(\MongoDB\Driver\Monitoring\CommandFailedEvent $event): void
    {
        ($this->callable)($event);
//        echo "commandFailed";
    }
}
