<?php

namespace Skoiy\Mongo\TypeMaps;

use MongoDB\BSON\Unserializable;
use Illuminate\Support\Collection as SupportCollection;

class Author implements Unserializable
{
    use \Skoiy\Mongo\Traits\Unserializable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'id', 'publicId', 'baseUrl', 'createdAt', 'updatedAt', 'isoLanguages', 'l10n'
    ];

    public function toArray(): array
    {
        $hasArray = [];
        foreach ($this->fillable as $attr) {
            if ($this->{$attr} instanceof SupportCollection) {

                $hasArray[$attr] = $this->{$attr}->toArray();
            } else {
                $hasArray[$attr] = $this->{$attr};
            }
        }
        return $hasArray;
    }

    public function __get($key)
    {
        return isset($this->{$key}) ? $this->{$key} : null;
    }
}
