<?php

namespace Skoiy\Mongo\TypeMaps;

use MongoDB\BSON\Unserializable;
use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Support\Collection as SupportCollection;

class Collection implements Unserializable, Arrayable
{
    use \Skoiy\Mongo\Traits\Unserializable;

    /** @var int */
    protected $id;

    /** @var int */
    protected $publicId;

    /** @var string */
    protected $slug;

    /** @var string */
    protected $baseUrl;

    /** @var array */
    protected $dossiers;

    /** @var string */
    protected $createdAt;

    /** @var string */
    protected $updatedAt;

    /** @var array */
    protected $isoLanguages;

    /** @var SupportCollection */
    protected $l10n;

    public function toArray(): array
    {
        return [
            'id' => $this->id,
            'publicId' => $this->publicId,
            'slug' => $this->slug,
            'baseUrl' => $this->baseUrl,
            'dossiers' => $this->dossiers,
            'createdAt' => $this->createdAt,
            'updatedAt' => $this->updatedAt,
            'isoLanguages' => $this->isoLanguages,
            'l10n' => $this->l10n->toArray(),
        ];
    }

    public function add($key, $value)
    {
        $this->{$key} = $value;
        return $this;
    }

    public function __get($key)
    {
        return isset($this->{$key}) ? $this->{$key} : null;
    }
}
