<?php

namespace Skoiy\Mongo\TypeMaps;

use MongoDB\BSON\Unserializable;

abstract class GenericDocument implements Unserializable
{
    use \Skoiy\Mongo\Traits\Unserializable;

    public $_id;
    public $data;
    public $_rev;
    public $_created_at;
    public $_updated_at;

    /**
     * toArray
     *
     * @return array
     */
    public function toArray(): array
    {
        // $this->data refers to a \Skoiy\Mongo\TypeMaps\Collection instance
        return $this->data->toArray();
    }

    public function add($key, $value)
    {
        $this->{$key} = $value;
        return $this;
    }

    public function __get($key)
    {
        return $this->{$key} ?? null;
    }
}
