<?php

namespace Skoiy\Mongo\TypeMaps;

use Illuminate\Contracts\Support\Arrayable;
use MongoDB\BSON\Unserializable;

class L10n implements Unserializable, Arrayable
{
    use \Skoiy\Mongo\Traits\Unserializable;

    public function toArray(): array
    {
        $data = get_object_vars($this);

        if (isset($this->authors) && $this->authors instanceof \Illuminate\Support\Collection) {
            $data['authors'] = $this->authors->toArray();
        }

        return $data;
    }

    public function add($key, $value)
    {
        $this->{$key} = $value;
        return $this;
    }

    public function push($key, $value)
    {
        if (!isset($this->{$key})) {
            $this->{$key} = [];
        }
        $this->{$key} = $value;
        return $this;
    }

    public function __get($key)
    {
        return isset($this->{$key}) ? $this->{$key} : null;
    }
}
