<?php

namespace Skoiy\Mongo\TypeMaps;

use MongoDB\BSON\Unserializable;
use Illuminate\Support\Collection;
use Illuminate\Contracts\Support\Arrayable;

class L10nCollection extends Collection implements Unserializable
{
    public function bsonUnserialize(array $l10ns)
    {
        return $this->push(...$l10ns);
    }

    public function append($key, $value)
    {
        $this->each(function(\Skoiy\Mongo\TypeMaps\L10n $l10n) use ($key, $value) {
            $l10n->add($key, $value);
        });
        return $this;
    }

    /**
     * toArray
     *
     * @return array
     */
    public function toArray(): array
    {
        return $this->map(function ($value) {
            return $value instanceof Arrayable ? $value->toArray() : $value;
        })->all();
    }
}
