<?php

namespace Skoiy\Mongo\TypeMaps;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Support\Collection;
use MongoDB\BSON\Unserializable;

class PostRelatedDocument implements Arrayable, Unserializable
{
    use \Skoiy\Mongo\Traits\Unserializable;

    private $id;
    private $isoLanguage;
    private $related_post_id;
    private $created_at;

    /**
     * toArray
     *
     * @return array
     */
    public function toArray(): array
    {
        return [
            'id' => (int)$this->id,
            'isoLanguage' => $this->isoLanguage,
            'idPostRelated' => (int)$this->related_post_id,
            'createdAt' => $this->created_at,
        ];
    }
}
